/*
fichier CTN_1.cfg
Nota:
il est imperatif de mettre un caractere SOULIGNE devant chaque parametre
et de respecter la syntaxe des variables.

_CALIBRATION=0
_PORT LPT=1
_FILTRE=0.2
_NBPT1000=2

_COUNT1000=130386.0
_COUNT2000=172700.0
_RATIO1000=1.93385
_RATIO2000=2.9652

_COUNT1000=150386.0
_COUNT2000=179700.0
_RATIO1000=1.920
_RATIO2000=2.980

*/


#ifdef __COMPACT__

#define CR printf("\n");

#include <stdio.h>
#include <stdlib.h>
#include <Dos.h>
#include <Bios.h>
#include <conio.h>
#include <math.h>
#include <time.h>
#include <string.h>

typedef enum {FALSE,TRUE} bool;
typedef unsigned char byte;
typedef unsigned int word;

word i,j,k,l,m,n;      /* variables a tout faire */
int Lpt;
char c;

float RR;              /* variables specifiques calcul serie */
int CALIBRATION;
static double Count1000[8];
static double Count2000[8];
static double Ratio1000[8];
static double Ratio2000[8];
static double xx,yy,zz;

int DEMO;
int NBPT1000=1;
int NumZoom=1;
long Taille;

float Filtre;
char NomFich[14];
char Convert[32];
FILE *f1;
char *Buff;
char *Tampon;

void Delay(int jjj)
{
int i;
while (jjj>0)
 {
 for (i=0;i<800;i++);
 jjj--;
 }
}

void Couine()
{
int i;
for (i=100;i<1000;i=i+10)
{
sound(i);
Delay(5);
nosound();
}
nosound();
}

void Pause(char ccc)
{
char c1;
 if (ccc>32)
  {
  printf("Appuyer sur <%c> ",ccc);
  }
  else
  {
   switch (ccc)
   {
   case 27:
   printf("Appuyer sur <ESC> ");
   break;
   case 13:
   printf("Appuyer sur <RETURN>");
   break;
   default:
   printf("Appuyer sur une Touche");
   break;
   }
 }
 c1=0;
 while((c1!=ccc)&&(c1!=27))
 {
 if (kbhit()) c1=getch();
 if (c1>96) c1=c1-32;
 }
}

void Errare()
{
  Couine();
  printf("\nerreur Fichier de config ligne %3d\n",l);
  sleep(3);
  exit(94);
}


void main (int argc,char *argv[])
{
clrscr();
textcolor(30);
cprintf("\nCONFPT.c    08 fev 97 \n");
textcolor(2);
Buff=(char *)malloc(600);
Tampon=(char *)malloc(200);
if(argc>1)
 {
  strcpy(Tampon,argv[1]);
  strupr(Tampon);
  if (strstr(Tampon,".CFG")==NULL)
   {
   printf("\n %s",strstr(Tampon,"PT1000.CFG"));
   printf("\nerreur fichier de config: %s",Tampon);
   sleep(2);
   Couine();
   exit(98);
   }
  printf("\nFichier de Configuration PT1000 passs en parametre=");
  cprintf(" %s.",Tampon);
  f1=fopen(Tampon,"r+b");
  i=fseek(f1,0,SEEK_END);
  Taille=ftell(f1);
  i=fseek(f1,0,SEEK_SET);
  printf("\ntaille fichier= %6ld octets\n",Taille);
  i=fread(Buff,Taille,1,f1);

  Tampon=strtok(Buff,"___________");
  l=0;
  if (strncmp(Tampon,"CALIBRATION",11)==0)
  {
   k=atoi(Tampon+13);
   CALIBRATION=k;
   printf("\nCalibration=%2d",k);
   }
   else  Errare();

  l=1;
  Tampon=strtok(NULL,"___________");
  if (strncmp(Tampon,"PORT LPT=",9)==0)
  {
   k=atoi(Tampon+9);
   switch (k)
   {
   case 1:
    Lpt=0x378;break;
   case 2:
    Lpt=0x278;break;
   default:
    Lpt=0x378;
   }
  }
  else   Errare();

  l=2;
  Tampon=strtok(NULL,"___________");
  if (strncmp(Tampon,"FILTRE=",7)==0)
  {
  Filtre=(float)atof(Tampon+7);
  }
  else   Errare();

  l=3;
  Tampon=strtok(NULL,"___________");
  if (strncmp(Tampon,"NBPT1000=",9)==0)
  {
   NBPT1000=atoi(Tampon+9);
  }
  else  Errare();

  if (NBPT1000>8) NBPT1000=8;
  if (NBPT1000<1) NBPT1000=1;
  for (j=0;j<NBPT1000;j++)
  {
  l++;
  Tampon=strtok(NULL,"_______________");
  if (strncmp(Tampon,"COUNT1000=",10)==0) Count1000[j]=atof(Tampon+10); else Errare();
  l++;
  Tampon=strtok(NULL,"_______________");
  if (strncmp(Tampon,"COUNT2000=",10)==0) Count2000[j]=atof(Tampon+10); else Errare();
  l++;
  Tampon=strtok(NULL,"_______________");
  if (strncmp(Tampon,"RATIO1000=",10)==0) Ratio1000[j]=atof(Tampon+10); else Errare();
  l++;
  Tampon=strtok(NULL,"_______________");
  if (strncmp(Tampon,"RATIO2000=",10)==0) Ratio2000[j]=atof(Tampon+10); else Errare();
  }

 fclose(f1);
 }
  else
  {
  printf("\nManque arguments...=> Lpt2 par dfaut,1 PT1000, Filtre=0.5..");
  printf("\nEx de commande :   CONFPT PT1000.cfg");
  printf("\n PT1000.cfg=contient le N de PORT LPT,le Nb de PT1000,valeur de filtre");
  printf("\n et les parametres de calibration de chaque sonde PT1000");
  Lpt=0x278;
  k=2;
  Filtre=0.5;
  NBPT1000=2;
  Count1000[0]=130386.0;
  Count2000[0]=172700.0;
  Ratio1000[0]=1.93385;
  Ratio2000[0]=2.9652;
  sleep(3);
 }
 printf("\nNombre de PT1000 = %3d",NBPT1000);
 printf("\nFiltre=%3.2f",Filtre);
 printf("\nPort LPT=%04x",Lpt);
 gotoxy(1,9);
 for (n=0;n<NBPT1000;n++)
 {
 printf("\nCoefficients de calibration PT1000 %2d :",n+1);
 printf("\nCounts a 1000 ohms 0C    =%8.0f",Count1000[n]);
 printf("\nCounts a 2000 ohms 260C  =%8.0f",Count2000[n]);
 printf("\nRatio  a 1000 ohms 0C    =%6.4f",Ratio1000[n]);
 printf("\nRatio  a 2000 ohms 260C  =%6.4f",Ratio2000[n]);
 sleep(3);
 }
printf("\n\n");
Pause('S');
textcolor(2);
}
#endif
#ifndef __COMPACT__
#error Please,passez en mode COMPACT !!!!
#endif