#include "windows.h"

// P.FREYER 24/02/97  
// rev 07/04/97
// rev 13 Mai 97  
// rev mai 2000
//  VISUAL C++ 1.5 
 
int donnee;
int counts;  
float Degres;
char Auteur[]="P.FREYER";
const float Volts=401;
const float Points=4096;

int LibMain(HANDLE hModule,WORD wDataSeg,WORD cbHeapSize,LPSTR lpszCmdLine)
{
 return (1);
}
             
 
void PASCAL __export Initialise (int Lptx)
{
 __asm
 {
    mov dx,Lptx     
    mov al,0    
	out dx,Al     
	mov dx,Lptx+1    
    mov al,0    
	out dx,Al
	mov dx,Lptx+2    
    mov al,0
	out dx,Al      

 }
} 
 

int PASCAL __export INPORTB (int Lptx)
{      
 __asm{
	mov dx,Lptx
	in al,dx  
	mov ah,0 
	mov donnee,ax 
	};     
	return(donnee);
}
          
          
int PASCAL __export inp (int Lptx)
{      
 __asm{
	mov dx,Lptx
	in al,dx  
	mov ah,0 
	mov donnee,ax 
	};     
	return(donnee);
}


void PASCAL __export OUTPORTB (int Lptx,int Value) 
{
 __asm {  
	mov ax,Lptx   
	mov dx,ax
	mov ax,Value 
	out dx,al
	};
}	
 
 
void PASCAL __export out (int Lptx,int Value) 
{
 __asm {  
	mov ax,Lptx   
	mov dx,ax
	mov ax,Value 
	out dx,al
	};
}	


    // (c) PF 04 aout 95   rev1    mai 96
	// parametre LPTx
	// En Sortie:	1 mesure de tension par adc AD7896    
	//		 		1 mesure de temperature si  usage de LM35DZ 10mV/C  
	//	 	 		alim stabilise via ZTR 4001  
	//            	format 12 bits pour 4.01V echelle resolution 1mV ou 0.1C
	//			  											   Dip8
	//	 Hardware:     	entree analogique	 					1
	//					masse analogique                    	6
	//				   	2=D0 = sortie clock                     4
	//	               	3=D1 = sortie selection boitier			7
	//	               	11=BUSY= entree pour lecture bit        5
	//				   	14=AUTO FEED = sortie pour alim montage 2
	//				   	10=ACK=status ADC						8
	//				   	25=Masse logique                        2
                    

                                                          
 

int PASCAL __export Presence(int Lptx)
{   
 Initialise(Lptx);
  __asm {  
    cli         
    Mov cx,0
	mov dx,Lptx
    mov al,0        
	out dx,Al	
    nop                  
    nop
    mov al,2      
    out dx,Al
    inc dx
encore: 
    in al,dx  
    inc cx
    cmp cx,0FFFFh
    jz sortie
 	test al,64
    jnz encore  
sortie:         
    mov [counts],cx 
    inc dx
    mov al,0
    out dx,al  
    dec dx
    dec dx
    sti
   	} ;    
   return(counts);
 } 
      
    
float PASCAL __export Temperature(int Lptx)   
{
  
  if (Presence(Lptx)!=0xFFFF)
  {
  __asm {    
    cli
	mov dx,Lptx
    mov al,0        
	out dx,Al	
    nop                  
    nop
    mov al,2      
    out dx,Al
    inc dx 
    nop
    nop
tbus1: 
    in al,dx
	test al,64
    jnz tbus1       

	dec dx
    mov cx,2048
    mov bx,0 
  
    mov al,3       
    out dx,al
    mov al,2      
    out dx,al
    mov al,3      
    out dx,al
    mov al,2       
    out dx,al
    mov al,3       
    out dx,al
    mov al,2      
    out dx,al
    mov al,3      
    out dx,al
    mov al,2     
    out dx,al
ICI:
    mov al,3      
    out dx,al
    inc dx         
    in al,dx       
    dec dx        
    test al,128
    jnz LABAS
	or bx,cx
LABAS:
    mov al,2       
    out dx,al
    shr cx,1
    jnc ICI 
     
	mov al,0
	out dx,al 
	mov ax,bx       
    and ax,3FFFh     
    mov counts,ax 
    sti
   	} ;    
  }
  else
  counts=0;
 return ((float)counts * Volts / Points);
}  


int PASCAL __export LectAdc(int Lptx)   
{
  __asm {  
    cli
	mov dx,Lptx
    mov al,2        
	out dx,Al	
    nop                  
    nop
    mov al,0      
    out dx,Al
    inc dx
tbus: 
    in al,dx
	test al,64
    jnz tbus       
    dec dx
    mov cx,2048
    mov bx,0
    mov al,2       
    out dx,al
    mov al,3      
    out dx,al
    mov al,2      
    out dx,al
    mov al,3       
    out dx,al
    mov al,2       
    out dx,al
    mov al,3      
    out dx,al
    mov al,2      
    out dx,al
    mov al,3     
    out dx,al
T1:
    mov al,2      
    out dx,al
    inc dx         
    in al,dx       
    dec dx        
    test al,128
    jnz T2
	or bx,cx
T2:
    mov al,3       
    out dx,al
    shr cx,1
    jnc T1 
  mov al,0
	out dx,al 
	inc dx
	inc dx
	mov al,0
	out dx,al 
   mov ax,bx       
    and ax,3FFFh     
    mov counts,ax 
    sti
   	} ;    
  return (counts);  
  
}

        