#ifdef __COMPACT__
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <graphics.h>
#include <alloc.h>
#include <conio.h>

/*#define NOT_REGISTERED*/
char Version[]={"(C)P.F.20/02/97"};

typedef enum {FALSE,TRUE} bool;
typedef unsigned char byte;
typedef unsigned int word;
typedef enum { ESCAPE=0x0011B,ENTER=0x1C0D,ESPACE=0x3920,CTRL_ENTER=0x1C0A };

union REGS Re,Rs;
struct REGPACK Rg;

#define CR printf("\n");
#define BUSY (inportb(Base+1)& Bit7)
#define Bit6 0x40
#define Bit7 0x80

int b,i,j,l,m;
long k,k1,k2;
char a,c,d,c1,c2;

/* variables specifiques mesure de temperature et grafe */

float Zero,Echelle;	/* valeur en counts des etalons 0 et 129.8 */
float Sensib,MaE;       /* coefficient de mise a l'echelle grafique */
float RatioE;		/* rapport de signal entre 0 et 129.8 etalons .*/
float RatioM; 	  	/* utilisation du rapport de signal 0,00  1,00 au lieu de val absolue*/
float RatioR,Rzero,Rechelle;
float Temp,Temp0;	/* variables pour elaborer le filtrage exponentiel */
float Temp2,OldTemp2;   /* variables graf NOW MESURE en ega ou vga only */
float Temp1;
float Moyenne;		/* moyenne temperature */
float BDeg,EDeg,Deg;    /*Debut,Fin d'echelle,Valeur en cours*/
float correction;
float PasDeg;           /* Graduations pour graphe ZOOM */
float ZMaE;		/* coef de Mise  l'echelle C et pixel en mode ZOOM*/

int Base;		/* adresse port paralle : LPt ou Proto */
int NbEch;		/* Population echantillonage mesure */
int Ps;			/* periode de stockage sur fichier */
int Tec; 		/* mesure du temps ecoul en secondes */

byte Secondes; 		/* variables pour detecter le changement de seconde */
byte OldSec;            /* pour etre compatible XT ne utiliser la RAM CMOS horloge*/
word *RbT; 		/* pointeur sur zone Ram comptage pulses 1/18 em de secondes */
long Pulse,OldPulse;

int DrpZOOM,ZOOM;       /* Zoom only si valeur de rference */
int DEMO;		/* si pas d'interface connect */

FILE *f1;
char Tampon[16];
char Nom[13];

long Taille;
int CarteGraphique,ModeGraphique,ErrorCode;
int MaxX,MaxY;
int Indice,x,Drap;
int Couleur;

char far  *Tableau1; /* stockage temporaire pour glissement courbe  grafe */
char far  *Tableau2;

void Ticks();
void InitGraf();
void Titre(int xx,int yy,int zz,char *msx);
void Grille();
word BUSYcount();
void Tarage();
void Calibration();
void Pause(char c1);
void delai(int jjj);
void Couine();
void Boof();
void Burp();
void Rideau();
void ToRegistered();

void Ticks()
{
 disable();
 Pulse=*(RbT)+*(RbT+2)*65535;
 if (Pulse>OldPulse+18)
 {
 Secondes++;
 OldPulse=Pulse;
 }
 enable();
}

void InitGraf()
{
 CarteGraphique=DETECT;
 if(registerfarbgifont(triplex_font_far) < 0)
  {
   Couine();
   printf("\nPb font TRIP non integree ..");
   sleep(2);
   exit(1);
   }
 if (registerfarbgifont(sansserif_font_far)<0)
   {
   Couine();
   printf("\nPb font SANS non integree ..");
   sleep(2);
   exit(1);
   }
 if (registerfarbgidriver(EGAVGA_driver_far )<0)
  {
   Couine();
   printf("\nPb Driver EGAVGA non integree ..");
   sleep(2);
   exit(1);
   }
  if (registerfarbgidriver(CGA_driver_far )<0)
  {
   Couine();
   printf("\nPb Driver CGA non integree ..");
   sleep(2);
   exit(1);
   }
 initgraph (&CarteGraphique,&ModeGraphique,"");
 ErrorCode=graphresult();
 if (ErrorCode!=grOk)
  {
  printf("erreur initialisation Grafique :%s \n",grapherrormsg(ErrorCode));
  sleep(2);
  exit(1);
  }
 MaxX=getmaxx();
 MaxY=getmaxy();
 gotoxy(3,3);
 printf("Initgraf.c");
 gotoxy(3,4);
 printf("Mode detect: ");
 switch (CarteGraphique)
 {
 case 1:printf(" CGA ");break;
 case 2:printf(" MCGA");break;
 case 3:printf(" EGA ");break;
 case 4:printf(" EGA 64 ");break;
 case 5:printf(" EGA mono");break;
 case 6:printf(" IBM 8514");break;
 case 7:printf(" HERCules");break;
 case 9:printf(" VGA ");break;
 case 10:printf(" PC3270 ");break;
 default:printf(" unknow ? ");break;
 }
 printf("  Max X= %5d      Max Y= %5d   ",MaxX,MaxY);
 sleep(1);
 clearviewport();
}

void Titre(int xx,int yy,int zz,char *msx)
{
 setfillstyle(SOLID_FILL,0);
 setcolor(Couleur);
 settextstyle(TRIPLEX_FONT,HORIZ_DIR,zz);
 bar(xx,yy,xx+90,yy+textheight(msx));
 outtextxy(xx,yy,msx);
 setcolor(10);
}

void BUSYCount()
{
int i;
k=0; k1=0;k2=0;
disable();
while (BUSY==0);          /* synchro sur front descendant */
while (BUSY==128);         /* synchro sur front montant */
while (BUSY==0); k2++;      /* synchro sur front descendant */
while (BUSY==128) k1++;     /* comptage front Haut */
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
while (BUSY==0)  k2++;
while (BUSY==128)  k1++;
enable();
k=k1+k2;
RatioR=(float)k2/(float)k1;
}

void Tarage()
{
int i;
if (DEMO==FALSE)
 {
 NbEch=10;
 outportb(Base,1);
 i=0;
 Zero=0.0;
 do {BUSYCount();Zero=Zero+(float)k; i++; } while (i<NbEch);
 outportb(Base,2);
 i=0;
 Echelle=0.0;
 do { BUSYCount();Echelle=Echelle+(float)k;i++;} while(i<NbEch);
 Sensib=129.8*NbEch/(Echelle-Zero);Echelle=Echelle/NbEch;Zero=Zero/NbEch;
 outportb(Base,4);
 }
 else
 {
 randomize();
 Zero=205788;
 Echelle=634186;
 Sensib=129.8/(Echelle-Zero);
 }
 gotoxy(1,23);
 RatioE=Echelle/Zero;
 printf("Zero=%6.0f  Echelle=%8.0f Sensibilite =%4.3fC par Cnt RatioE=%5.3f",Zero,Echelle,Sensib,RatioE);
 Zero=Zero/NbEch;
 Echelle=Echelle/NbEch;
}

void Calibration()
{
 NbEch=20;
 Indice=1;
 if (DEMO==FALSE)
 {
  printf("\n\nD0=1 Etalon de 1000 ohms = 0C");
  outportb(Base,1);
  i=0;Zero=0.0;
  do
  {
   BUSYCount();
   Zero=Zero+(float)k;
   i++;
   printf(".");
   }
  while (i<NbEch);
  Rzero=RatioR;
  printf("\nD1=5  Etalon de 1500 ohms =259.74C");
  outportb(Base,2);
  i=0;  Echelle=0.0;
  do
  {
   BUSYCount();
   Echelle=Echelle+(float)k;
   i++;
   printf(".");
  }
  while(i<NbEch);
  Rechelle=RatioR;
  outportb(Base,4);
  }
 else
 {
  Zero=138740.0;
  Echelle=451348.0;
 }

 printf("\n");
 Echelle=Echelle/(float)NbEch;
 Zero=Zero/(float)NbEch;
 Sensib=129.8/(Echelle-Zero);
 printf("\nZero   =%12.2f counts",Zero);
 printf("\nEchelle=%12.2f counts",Echelle);
 printf("\n\nSensibilite =%5.4f C par count soit %8.2f points pour 129.8C",Sensib,Echelle-Zero);
 RatioE=Echelle/Zero;
 printf("\nRatio ETALON <1.159 +- 0.01> =%6.4f",RatioE);
 printf("\nFin de calibration.. ");
 if ((RatioE<1.169)&&(RatioE>1.149))
  printf("..OK  ");
  else
  {
  Couine();
  printf ("..Bad ! ");
 }
 printf("\n");
}

void Pause(char c1)
{
 char c;
 printf("appuyer sur %c",c1);
 do
 {
  if (kbhit()) c=getch();
  if (c>96) c=c-32;
 }
 while (c!=c1);
}

void delai(int jjj)   /* delai exprim en Milllisecondes */
{
 int iii;
 while (jjj>0)
 {
  for (iii=0;iii<800;iii++);
  jjj--;
 }
}

void Couine()
{
 int i,iii;
 for (i=100;i<1000;i=i+10)
 { sound(i); for (iii=0;iii<2000;iii++); nosound();}
 nosound();
}

void Boof()
{
int i;
 for (i=500;i>100;i=i-50)
 {
 sound(i);delai(5);
 }
 nosound();
}

void Burp()
{
 sound(300);
 delai(100);
 nosound();
}



void main (int argc,char *argv[])
{
clrscr();
correction=0.0;
if (argc>1) correction=atof(argv[1]);
printf("\ncorrection passe en parametre=%5.3f",correction);
DEMO=TRUE;
RbT= MK_FP (0x0040,0x006c);
Pulse=*(RbT)+*(RbT+2)*65535;
OldPulse=Pulse;
clrscr();
printf("\nTstPt.c %s",Version);
printf ("\nQuel port imprimante LPT <1> <2> : ");
fflush(stdin);
scanf("%d",&c);
switch (c)
 {
 case 2:
  Base=0x278;
  c=50;
  break;
  case 1:
  default:
  c=49;
  Base=0x378;
 }
 outportb(Base,4);
 textcolor(YELLOW);
 printf(" soit Port choisi  : base =");cprintf("%04X ",Base);
 Ticks();
 a=Secondes;
 printf("\nTest presence impulsion pendant 2 secondes ou <Q>uitter ");
 b=0;d=0;
 c2=0;
 k=0;
 while (c2!='Q'&& Secondes<a+2)
 {
 k=BUSY;
 gotoxy(1,6);
 printf("Port %x= %4d  compteur=%12ld   Secondes=%3d",Base+1,k,b,Secondes);
 if (k==128 && d==0) { b++;d=1;}
 if (k==0  && d==1) { b++;d=0;}
 if (kbhit()) c2=getch();
 Ticks();
 }
 if (b<2)
 {
  printf("\n\nFin anormale...PROBLEME :");
  printf("\nPas de signal detect sur BUSY lpt%c .....\n",c);
  Couine();
  sleep(1);
  printf("\nDonc mode DEMO !!..");
  sleep(1);
  DEMO=TRUE;
  }
  else
  {
   printf("\nOK..signal present sur BUSY LPT%c ...",c);
   DEMO=FALSE;
 }
 Calibration();
 printf("\n");
 Pause('S');
 if (DEMO==FALSE) BUSYCount(); else k=20000+random(200);
 RatioM=(RatioR-Rzero)/(Rechelle-Rzero);
 RatioM=RatioR/RatioE;
 Temp0=RatioM*129.8+correction;
 MaE=(MaxY-1-MaxY/5)/20.0;
 ZMaE=(MaxY-1-MaxY/5)/2.0;
 ZOOM=FALSE;
 DrpZOOM=FALSE;
 Indice=1;
 c2=0;

 /* ---------------- Corps Principal ------------*/

 Moyenne=0.0;
do
 {
 if (kbhit()!=0) c2=(char)getch();
 if (c2>96) c2=c2-32;
 if (DEMO==FALSE) BUSYCount(); else k=20000+random(125);
 RatioM=(RatioR-Rzero)/(Rechelle-Rzero);
 Temp0=RatioM*129.8+correction;
 Ticks();
  if (kbhit()) {c2=getch(); if (c2>96) c2=c2-32;}
  if (c2=='D')  outportb(Base,1);
  if (c2=='F')  outportb(Base,2);
  if (c2=='X')  outportb(Base,4);
  if (c2==27)  break;
  if (c2=='T')
   {
    if (DEMO==FALSE) Tarage();else Burp();
    c2=0;
   }
  gotoxy(1,22);
  printf("c2=%c Cnt=%7ld  Ind=%5d  RatioM=%5.4f   Deg=%6.3f   RatioR= %5.4f",c2,k,x,RatioM,Temp0,RatioR);
  x++;
  if (x % 60==0) Tarage();
  }
 while (c2!=27);
}

#endif
#ifndef __COMPACT__
#error mode COMPACT siouplait
#endif


