screen 0,0,0
clear
cls
defint I,j,K
OPTION BASE 0


 rem couleurs disponibles en mode 8 EGA ou mode 0 texte CGA,EGA
 Noir=0   : MarineF=1 : VertF=2 : BleuF=3   : RougeF=4  : Mauve=5
 Marron=6 : GrisC=7   : GrisF=8 : MarineC=9 : Vert=10   : Bleu=11
 Rouge=12 : Violet=13 : Jaune=14: Blanc=15

dim Permited(4)            ' pour test hardcopy

rem variables d usage general
dim month$(12),month%(12)    ' libelle et nb de jours des mois
dim JourSem$(8)              ' Jours de la semaine

JoursSemaine:
data Lundi,Mardi,Mercredi,Jeudi,Vendredi,Samedi,Dimanche,Lundi
for j=0 to 7:read JourSem$(J):next j
data "        ",0,"Janvier",31,"Fevrier",28,"Mars",31,"Avril",30,"Mai",31
data "Jun",30,"July",31,"Aout",31,"Septembre",30,"Octobre",31,"Novembre",30
data "Decembre",31
for j=0 to 12: read  Month$(j):Read month%(j):next j

call what.time

rem initialisation des variables specifiques a ce programme

LPTx=&h278  'LPT2

dim dummy(32)
dim ActiveBit(5)
dim AncienY(5)
dim Mesure&(5)
dim unite$(5)
dim Donnees(5)
dim ValGlis(20,5)
dim A0(5),A1(5),A2(5),A3(5)

ActiveBit(1)=4:ActiveBit(2)=8:ActiveBit(3)=16:ActiveBit(4)=32
NomFichier$="CTN1___.CFG"

' exemple fichier de configuration
'_CALIBRATION=0
'_PORT LPT=2
'_FILTRE=0.8
'_NBCTN=2
'_COEF[00]=-5.8019
'_COEF[01]=-31.457
'_COEF[02]=-21.972
'_COEF[03]=-8.5395
'_COEF[04]=-1.1075
'_COEF[05]=-15.51
'_COEF[06]=-0.9183
'_COEF[07]=-0.9893

if len(command$)>6 then
   A$=command$
   a$=ucase$(a$)
   if right$(a$,4)=".CFG" then Nomfichier$=a$
   else
   Nomfichier$="CTN.CFG"
end if

on error goto TraitErreur

Open NomFichier$ for input as #1

if erreur =53 then
   print "Valeurs par dfaut car ";NomFichier$;" non accessible :"
   print " celui-ci doit etre dans le meme directory!..ou dsign dans APPEND."
   delay 1
   PortLpt=1
   NombreCTN=2
   Filtre=0.8
   Calibrer=0
   A0(1)=-5.8019
   A1(1)=-31.457
   A2(1)=-21.972
   A3(1)=-1.1075
   A0(2)=-15.51
   A1(2)=-20.2789
   A2(2)=-0.9183
   A3(2)=-0.9893
 else
  ? "lecture fichier ";NomFichier$
  k=1
  do
   input #1,A$
   print a$
   j=instr(a$,"=")
   a$=right$(a$,len(a$)-j)
   Dummy(k)=val(a$)
   incr k
 loop while not eof(1)
 close #1
 delay 2
 cls
 Calibrer=Dummy(1)
 PortLpt=Dummy(2)
 Filtre=Dummy(3)
 NombreCTN=Dummy(4)

 for j=1 to NombreCTN
    A0(j)=Dummy(5+(j-1)*4)
    A1(j)=Dummy(6+(j-1)*4)
    A2(j)=Dummy(7+(j-1)*4)
    A3(j)=Dummy(8+(j-1)*4)
  next j
print "Valeurs issue du fichier de configuration : ";NomFichier$
end if

?"Nombre de CTN=";NombreCTN
for i=1 to NombreCTN
?"A0(";i;")=";
? using "####.### ";A0(i)
?"A1(";i;")=";
? using "####.### ";A1(i)
?"A2(";i;")=";
? using "####.### ";A2(i)
?"A3(";i;")=";
? using "####.### ";A3(i)
?"-----------------"
next i

select case PortLpt
  case 1
    Lptx =&h378
  case 2
   Lptx=&h278
end select
?"Port Lpt= ";PortLpt;" soit ";LPtx
delay 2
cls

Zooming$="NON"
Moyenne=20.0
MaxX=640   :rem axe des X sur 600
MaxC=20    :rem echelle maxi C
x&=0

$include "Regnames.inc"

screen 0,0,0

'--------------------------

DO
 cls
 color 13,0
 call Titre("Mes2CTN.bas  (c)P.F.93 rev 1296",4,1)
 color 7,0
 locate 5,1
 print "Utilise le meme interface que CTNTEGL.exe et 2CTN68K.exe en C"
 locate 6,1
 ?"rappel pratique : 1Heure=3600s 1jour=86400s "
 TT=FNCombien.Entier(7,1,"Nombre TOTAL de mesure  ",10,32000)
 MiniTe=2+0.5*NombreCTN
 Te=FNCombien.Entier(8,1,"Interval de Temps Echantillonnage en secondes ",MiniTe,3600)
 color 15
 locate 9,1
 ?using "soit total de ########## sec ou ####.## Heures";TT*Te;TT*Te/3600
 MaxC=FNCombien.ENtier(10,1,"Maxi Echelle en degres ",20,80)
 color 7,0
 locate 11,1
 input "Moyennage des mesures <O> ou au fil de l'eau <N> ";A$
 a$=ucase$(a$)
 if a$="O" then filtrage=1 else filtrage=0
 locate 12,1
 input "Nom du fichier de stockage (essai.PRN par dfaut):";nom$
 if len(Nom$)=0 then Nom$="Essai.prn"
 if instr(Nom$,".")=0 and len(nom$)<8 then nom$=nom$+".PRN"
 open nom$ for binary as #3
 seek #3,1
 ?"fichier ";nom$;" ouvert"
 TailleFichier&=lof(3)
 ?"lof(3)=";TailleFichier&
 if TailleFichier&>0 then
  beep
  ?"Fichier NON vide !!"
  input "Le detruire ?? <O> <N> ";a$
  a$=ucase$(a$)
  if a$<>"O" then
   beep
   ?"abort programme.."
   delay 2
   stop
   else
    close #3
    kill nom$
    beep
    open nom$ for binary as #3
    seek #3,1
    ?"fichier ";nom$;" ouvert apres destruction de l'ancien fichier."
    TailleFichier&=lof(3)
    ? "lof(3)=";TailleFichier&
  end if
end if
?
input " parametrage OK <O,N> ? "a$
a$=ucase$(a$)
a$=left$(a$,1)
LOOP until a$="O"
'--------------------------------------------------

NbEMax=TT
N=NbeMax
if N>MaxX then
 while MaxX<N
  N=N/2
 wend
end if
MaxX=N
PasX=N/10

screen 12
view
cls
MaxLigne=34:HautCar=14:gosub PreparePolice8x14         rem  34 lignes
Zoom=1.0
call Grille(0,MaxX,MaxC/2,0,96,639,460,Zoom)

ON TIMER(Te) gosub Avance
TIMER ON

color 15,0
locate 1,1
?using "Fichier :\          \ ";nom$
color 2,0
Nf=0		'compteur filtrage
NbE=0           'compteur Echantillons
Zooming$="NON"
Moyenne=20.0
Zoom=1.0

DO
 x&=0
 AncienX&=0
 gosub Calibration

 DO
  gosub MesureCTN
  for ii=1 to NombreCTN
   R=((Mesure&(ii)-Zero&)/Zero&)/RatioStd
   R1=log(R)
   jj!=A0(ii)+A1(ii)*R1+A2(ii)*R1*R1+A3(ii)*R1*R1*R1
   gosub AfficheValeur
   Donnees(ii)=jj!
   Somme(ii)=Somme(ii)+jj!
   if instat then clav$=inkey$
   if clav$=chr$(27) then gosub Abort
  next ii
  Nf=Nf+1
 call what.time
 if clav$=chr$(27) then gosub Abort
 if ((clav$="+") and (Zoom<=8) and (Zooming$="OUI")) then
    	TIMER OFF
    	Zoom=Zoom*2
    	call Grille(0,MaxX,Moyenne,0,96,639,460,Zoom)
    	color 2,0
	locate 5,42
	?" +-";
	?using "Zooming=##.# ";Zoom
    	clav$=""
    	x&=MaxX
    	TIMER ON
   end if
  if ((clav$="-") and (Zoom>=2.00) and (Zooming$="OUI")) then
    	TIMER OFF
    	Zoom=Zoom/2
    	call Grille(0,MaxX,Moyenne,0,96,639,460,Zoom)
    	color 2,0
    	locate 5,42
	?" +-";
	?using "Zooming=##.# ";Zoom
    	x&=MaxX
    	clav$=""
    	TIMER ON
  end if
 LOOP until(( x&>=MaxX) or (NbE>=NbEMax))
LOOP until NbE>=NbEMax

TIMER OFF
TIMER STOP
close  #3
mes$="Fin de mesure .....    "
lig=6:col=10:Attr=2
gosub EcrisM13
delay 0.5
Beep
mes$="Appuyer sur ESC pour sortir"
lig=6:col=10:Attr=2
gosub EcrisM13
c$=""
do
	if instat then c$=inkey$
loop while c$<>chr$(27)
stop


Avance:
if Nbe=1 then
 put$ 3,date$
 put$ 3,chr$(9)
 put$ 3,chr$(13)
 put$ 3,chr$(10)
 put$ 3,Nomfichier$
 put$ 3,chr$(13)
 put$ 3,chr$(10)
end if
put$ 3,time$
put$ 3,chr$(9)
for i=1 to NombreCTN
 ValGlis(int(x&) mod 20,i)=Donnees(i)
 if x&=0 then
   pset(x&,Donnees(i)),2+i
   else
  line(AncienX&,AncienY(i))-(x&,Donnees(i)),2+i
 end if
 AncienY(i)=Donnees(i)
 if Filtrage=1 then
  Donnees(i)=Somme(i)/Nf
 end if
 VA!=fix(Donnees(i)*1000.0+0.5)
 va$=str$(VA!/1000.0)
 put$ 3,va$
 put$ 3,chr$(9)
 Somme(i)=0
next i
AncienX&=x&
Nbe=Nbe+1
x&=x&+1
put$ 3,chr$(13)
put$ 3,chr$(10)
locate 5,1
?using "Nbe =###### / ########  ";nbe;NbeMax
if x&>20 then
  Moyenne=0
  for j=1 to NombreCTN
   for i=0 to 19:Moyenne=Moyenne+ValGlis(i,j)
   next i
  next j
  Moyenne=Moyenne/40.0
  Zooming$="OUI"
  color 2,0
  locate 5,42
  ?" +-";
  ?using "Zooming=##.# Moyenne=###.###";Zoom;Moyenne
end if
nf=0
if (Nbe mod 10=0) then
   gosub Calibration
end if
return

Calibration:
$event off
k&=0
out LPTx,2
out LPTx,2 or 128
while (inp(Lptx+1)and 64)=0
incr k&
wend
Echelle&=k&
k&=0
out LPTx,1
out LPTx,1 or 128
while (inp(Lptx+1) and 64)=0
incr k&
wend
Zero&=k&
RatioStd=(Echelle&-Zero&)/Zero&
$event on
if RatioStd<12.5 or RatioStd>14.5 then
  ?
  ?using "Erreur sur RatioStd ... ##.### ";RatioStd
  ?"valeur normale =13.5 +- 1.0"
  ?
  delay 2
  Stop
  end if
 locate 2,1
 ?using " Zero=####### Echelle=#######  RatioStd=##.####  Filtrage=# ";Zero&;Echelle&;RatioStd;Filtrage

return

MesureCTN:
for kk=1 to NombreCTN
$event off
k&=0
out LPTx,ActiveBit(kk)
out LPTx,ActiveBit(kk) or 128
while (inp(Lptx+1) and 64)=0
incr k&
wend
$event off
Mesure&(kk)=k&
next kk
return

Abort:
Beep
mes$=" Arret programme sur cde ESC.."
lig=6:col=10:Attr=2
gosub EcrisM13
close
beep
Stop
return

AfficheValeur:
  locate 2+ii,1
  color 7,0
  ?"Sonde N";ii;
  locate 2+ii,20
  color 10+ii,0
  print using "= ###.### \\  ##.#### #######";jj!;Unite$(ii);R;Mesure&(ii)
  color 7,0
return

DEF FNJourDate$ (Jdate)
Local i,j,k,L
L=annee
if Jdate>Numjour then decr L
IF Jdate <1 or Jdate > 365-(l mod 4=0) then
a$="erreur/jour"
beep
ELSE
Month%(2)=28-(L mod 4=0)
i=0 :k=0
do
 incr i
 k=k+month%(i)
 if k >=Jdate then
  j=Jdate-k+month%(i)
  exit Loop
 end if
loop until i>11
a$=str$(j)
a$=right$(a$,len(a$)-1)
if len(a$)<2 then a$="0"+a$
a$=a$+" "+left$(month$(i),4)+" "+right$(str$(L),2)
END if
FNJourDate$=A$
Month%(2)=28-(Annee mod 4=0)
End DEF

Sub What.time
local b$
shared numjour,THeur,TMin,Tsec,jour,mois,annee,month%(),month$(),joursem$(),joursem
 out &h70,4:Theur=inp(&h71)
 out &h70,2:Tmin=inp(&h71)
 out &h70,0:Tsec=inp(&h71)
 out &h70,6:JourSem=inp(&h71)
 out &h70,7:Jour=inp(&h71)
 out &h70,8:Mois=inp(&h71)
 out &h70,9:Annee=inp(&h71)
if Annee<>255 and Mois<>255 and jour<>255 then
  Jour=val(hex$(Jour))
  Mois=val(hex$(Mois))
  annee=val(hex$(Annee))
  call JourCalendaire
  locate 1,50
  Print using"## \   \ ##  \\:\\:\\   Nj=###";Jour;Month$(Mois);Annee;hex$(Theur);hex$(Tmin);hex$(Tsec);numjour;
 end if
End sub

DEF FNFrenchDate$ (A$)
local j%
mois$=left$(a$,2):mois=val(mois$)
Jour$=Mid$(a$,4,2):jour=val(jour$)
Annee$=Right$(A$,2):Annee=Val(Annee$)
FNfrenchdate$=Jour$+"/"+mois$+"/"+Annee$
Call JourCalendaire
End DEF

SUB JourCalendaire
local j%
shared numjour,Jour,Mois,annee,month%()
if annee mod 4=0 then
   month%(2)=29
   else
    month%(2)=28
    end if
j%=0
Numjour=0
For j%=1 to mois-1
 Numjour=Numjour+month%(j%)
Next j%
Numjour=Numjour+Jour
end Sub

EcrisM13:
def seg
Ofs&=varptr(mes$)                    'offset pointeur chaine
Sg&=varseg(mes$)                    'seg pointeur chaine
def seg=Sg&
Of&=peek(Ofs&+3) 		   'deplacement dans chaines
Of&=Of&*256+peek(Ofs&+2)    'deplacement dans chaines
def seg
Sg&=peek(1)
Sg&=Sg&*256+peek(0)      'segment des chaines
Reg 3,len(mes$)
Reg 1,&h1300
reg 4,lig*256+col
Reg 2,Attr                      'Attribut couleur 1=bleu fc 10=vert intense
Reg 7,Of&
Reg 9,Sg&
call interrupt(&h10)
return

PreparePolice8x14:    ' 43 lignes en VGA
Reg 1,&h1122
Reg 2,&h0003
Reg 4,80	
call interrupt(&h10)
return

SUB Grille(MinX,MaxX,Mean,MinXreel,MinYreel,MxReel,MyReel,Zoom)
local i,MoyY,MinY,MaxY
shared Attr,mes$,col,lig,MaxLigne,HautCar,MaxC
Attr=6	
View (MinXreel,MinYreel)-(MxReel,MyReel)
cls
MoyY=fix(Mean*1000)/1000
MinY=MoyY-(MaxC/2)/Zoom
MaxY=MoyY+(MaxC/2)/Zoom
DY=(MaxY-MinY)/10.0
Window(MinX,MinY)-(MaxX,maxY)
for i!=MinY to MaxY step DY
 mes$=str$(fix(i!*100)/100)
 mes$=right$(mes$,len(mes$)-1)
 mes$=left$(mes$,5)
 lig=pmap(i!,1)\HautCar:
 col=pmap(MinX,0)\8
 if lig<Maxligne then Attr=3:gosub EcrisM13
next i!
View (40+MinXreel,MinYreel)-(MxReel,MyReel),0   '<- couleur was 8
Window(MinX,MinY)-(MaxX,MaxY)
line(MinX,MinY)-(MaxX,MaxY),15,B
for i!=MinY+DY to MaxY-DY step DY
 line (MinX,i!)-(MaxX,i!),8,,&h0404    ' <- couleur was 0
next i!
lig=(MyReel\HautCar)+1
DX=(MaxX-MinX)/10
for x=MinX+DX to MaxX step DX
 line (x,MinY)-(x,MaxY),8,,&h0404     ' <- couleur was 0 et was &h0F0F
  mes$=str$(int(x))
  col=int((pmap(x,0)\8)-(len(mes$)/2))
  if (col+len(Mes$))<80 then  Attr=3: gosub EcrisM13
 next x
END SUB


GrilleVGA:
screen 12
view
cls
view (0,0)-(639,479),0
cls
View (0,111)-(631,460),0     : :rem  Nouvelles dimensions ecran
Window(0,0)-(MaxX,MaxY)      ::rem  il faut mettre plus de 240 sinon debordement avec PUT
cls
Attr=6				:rem  couleur valeurs axes x et y
for i=0 to MaxY step 5
 lig=pmap(i,1)\16: col=0
 mes$=str$(i)
 if lig<30 then gosub EcrisM13
next i
View (39,111)-(638,460),0    : :rem  Nouvelles dimensions ecran  was 39,128
Window(0,0)-(MaxX,MaxY)
cls
line(0,0)-(MaxX,MaxY),15,B
for i=10 to MaxY-1 step 10
 line (0,i)-(MaxX,i),8,,&h0F0F
next i
for x=PasX to MaxX-PasX step PasX
 line (x,0)-(x,MaxY),8,,&h0F0F
  col=(pmap(x,0)/8)-(len(str$(x))/2): lig=29
  mes$=str$(x)
  if lig<30 then gosub EcrisM13
next x
return

Sub Titre(titr$,Ox,Oy)
 LOCATE OY,OX
 PRINT CHR$(201);STRING$(LEN(TITR$)+4,CHR$(205));CHR$(187)
 LOCATE OY+1,OX:PRINT CHR$(186);"  ";TITR$;"  ";CHR$(186)
 LOCATE OY+2,OX:PRINT CHR$(200);STRING$(LEN(TITR$)+4,CHR$(205));CHR$(188)
END Sub


rem: PF 18/08/88
Sub Curseur (lign%,col%)     :rem  positionne le curseur en Ligne,colonne
local N%                   :rem  raz jusqu a la Fin de ligne avec des blancs
Locate lign%,Col%            :rem  et remet le curseur en position
N%=80-col%
?space$(N%);
locate lign%,Col%
End Sub

$include "alphabet.inc"


Def FNCOMBIEN.Entier (lign,Col,A$,mini,maxi)
local o,j,k$,i$,f$,b$,k,signe,tt0!,x,y,Mi$,Ma$
comb1:
Mi$=str$(mini)
Ma$=str$(maxi)
Mi$=string$(len(Mi$),"#")
Ma$=string$(len(Ma$),"#")
delay 1
f$="\"+space$(len(A$))+"\"+" de <"+Mi$+">  <"+ma$+"> "
locate lign,col
color 7,0
?using f$;a$;mini;maxi;
k$=""
tt0!=timer
x=pos(o):y=csrlin
?"      ";
color 3,0
locate y,x
i$=""
do
 b$=inkey$
 if b$<>"" then
    if asc(b$)=13 then
      exit Loop
      else
      if b$>=" " then
        ?b$;
        i$=i$+b$
       end if
      end if
   End if
 loop until len(i$)>5
if i$="" then
  i=mini+(maxi-mini)\2
else
 signe=1
 if left$(i$,1)="-" then
  signe=-1
  i$=right$(i$,len(i$)-1)
  color 11,0
  end if
 j=1
 do
  k$=mid$(i$,j,1)
  k=asc(k$)
  select case k
  case 48 to 57
  incr J
  case else
  goto Comb1
  end select
 Loop until j>=len(i$) or timer>tt0!+60
 i=val(i$)*signe
 if (i<Mini) or (i>maxi) then
    beep
   goto comb1
  else
  color 10,0
 end if
end if
locate y,x-1
?using"######";i;
FnCombien.entier = I
End def


Traiterreur:
' $event off
 Col=pos(0)
 lign=csrlin
select case err
case 6
   MesEr$="Depassement de capacite sur numerique"
case 11
   MesEr$="Division par ZERO "
case 27
   MesEr$="Imprimante hors tension ou manque papier"
case 52
   MesEr$="Numero de fichier bad ou indice Hors limite"
case 53
   MesEr$="Fichier inexistant ou introuvable      "
case 55
   MesEr$="Fichier dja ouvert"
case 57              ' traitement pour differencier COM1 ou LPT1
   EtatLp=inp(&H379)
   select case EtatLp
    case 87
     MesEr$=" Imprimante  OFF LINE  "
    case 135
     MesEr$=" Imprimante HORS TENSION "
    case 119
     MesEr$=" Plus de papier sur LP "
    case else
     MesEr$= " Communication ....   "
    end select
case Else
   Meser$=""
End Select
call curseur(24,1)
?using "erreur ### : ";err;
?mesEr$;
delay 2
call curseur(24,1)
locate lign,Col
'$event on
erreur=err
Resume next


